// Generated from DyBIP.g4 by ANTLR 4.4
package antlr4;
import org.antlr.v4.runtime.misc.NotNull;
import org.antlr.v4.runtime.tree.ParseTreeVisitor;

/**
 * This interface defines a complete generic visitor for a parse tree produced
 * by {@link DyBIPParser}.
 *
 * @param <T> The return type of the visit operation. Use {@link Void} for
 * operations with no return type.
 */
public interface DyBIPVisitor<T> extends ParseTreeVisitor<T> {
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#exprQuadruple}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprQuadruple(@NotNull DyBIPParser.ExprQuadrupleContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#inequalityExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInequalityExpr(@NotNull DyBIPParser.InequalityExprContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#motifType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMotifType(@NotNull DyBIPParser.MotifTypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#data}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitData(@NotNull DyBIPParser.DataContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#sizeAccess}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSizeAccess(@NotNull DyBIPParser.SizeAccessContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#guard}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitGuard(@NotNull DyBIPParser.GuardContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#reconfigurationRule}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitReconfigurationRule(@NotNull DyBIPParser.ReconfigurationRuleContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#range}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRange(@NotNull DyBIPParser.RangeContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#initTransition}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInitTransition(@NotNull DyBIPParser.InitTransitionContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#exprUnary}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprUnary(@NotNull DyBIPParser.ExprUnaryContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#rules}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitRules(@NotNull DyBIPParser.RulesContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#nestedIterators}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitNestedIterators(@NotNull DyBIPParser.NestedIteratorsContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#portAssign}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitPortAssign(@NotNull DyBIPParser.PortAssignContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#type}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitType(@NotNull DyBIPParser.TypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#exprLiteral}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprLiteral(@NotNull DyBIPParser.ExprLiteralContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#forIterator}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitForIterator(@NotNull DyBIPParser.ForIteratorContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#iterator}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitIterator(@NotNull DyBIPParser.IteratorContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#exprVariable}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprVariable(@NotNull DyBIPParser.ExprVariableContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#interactionRule}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInteractionRule(@NotNull DyBIPParser.InteractionRuleContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#guardActionPair}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitGuardActionPair(@NotNull DyBIPParser.GuardActionPairContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#action}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAction(@NotNull DyBIPParser.ActionContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#expr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExpr(@NotNull DyBIPParser.ExprContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#motifAction}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMotifAction(@NotNull DyBIPParser.MotifActionContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#componentType}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitComponentType(@NotNull DyBIPParser.ComponentTypeContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#interReconfigurationRule}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitInterReconfigurationRule(@NotNull DyBIPParser.InterReconfigurationRuleContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#motifInstance}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMotifInstance(@NotNull DyBIPParser.MotifInstanceContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#exprBinary}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprBinary(@NotNull DyBIPParser.ExprBinaryContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#equalityTerms}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitEqualityTerms(@NotNull DyBIPParser.EqualityTermsContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#assignment}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAssignment(@NotNull DyBIPParser.AssignmentContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#exprAction}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitExprAction(@NotNull DyBIPParser.ExprActionContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#moreMathTerms}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMoreMathTerms(@NotNull DyBIPParser.MoreMathTermsContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#moreEqualityTerms}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMoreEqualityTerms(@NotNull DyBIPParser.MoreEqualityTermsContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#transition}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitTransition(@NotNull DyBIPParser.TransitionContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#functionUnary}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitFunctionUnary(@NotNull DyBIPParser.FunctionUnaryContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#dotAccess}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitDotAccess(@NotNull DyBIPParser.DotAccessContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#andorTerms}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAndorTerms(@NotNull DyBIPParser.AndorTermsContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#system}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitSystem(@NotNull DyBIPParser.SystemContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#functionBinary}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitFunctionBinary(@NotNull DyBIPParser.FunctionBinaryContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#portAssignStmts}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitPortAssignStmts(@NotNull DyBIPParser.PortAssignStmtsContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#mathExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitMathExpr(@NotNull DyBIPParser.MathExprContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#referMotif}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitReferMotif(@NotNull DyBIPParser.ReferMotifContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#port}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitPort(@NotNull DyBIPParser.PortContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#portAccess}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitPortAccess(@NotNull DyBIPParser.PortAccessContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#componentInstance}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitComponentInstance(@NotNull DyBIPParser.ComponentInstanceContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#variable}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitVariable(@NotNull DyBIPParser.VariableContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#forEachIterator}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitForEachIterator(@NotNull DyBIPParser.ForEachIteratorContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#equalityExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitEqualityExpr(@NotNull DyBIPParser.EqualityExprContext ctx);
	/**
	 * Visit a parse tree produced by {@link DyBIPParser#andorExpr}.
	 * @param ctx the parse tree
	 * @return the visitor result
	 */
	T visitAndorExpr(@NotNull DyBIPParser.AndorExprContext ctx);
}