package dybip.InteractionStmt;

import dybip.Context;
import dybip.IndexMap;
import dybip.expression.list.ActionList;

public class EnabledInterReconfiguration extends EnabledStep{

	public EnabledInterReconfiguration(ActionList actionList, IndexMap indexMap) {
		setActionList(actionList);
		setIndexMap(indexMap);
	}
	@Override
	public void execute(Context context) {
		context.setIndexMap(getIndexMap());
		// set motif variable list
		getActionList().minify(context).value(Boolean.class);
		context.resetIndexMap();
		context.resetMotifListMap();
	}

	@Override 
	public String toString() {
		String str = "\n\t\t" + getActionList().toString() +  getIndexMap().toString() + "\n";
		return str;
	}
	@Override
	public String toMinifyString(Context context) {
		return "";
	}

}
