package dybip.InteractionStmt;

import dybip.Context;
import dybip.DyBIPObject;
import dybip.IndexMap;
import dybip.expression.list.ActionList;

public abstract class EnabledStep extends DyBIPObject{
	private ActionList updateExpressions;
	private IndexMap indexMap;
	
	public abstract void execute(Context context);
	public abstract String toMinifyString(Context context);
	
	public void setIndexMap(IndexMap indexMap) {
		this.indexMap = indexMap;
	}
	public void setActionList(ActionList actionList) {
		this.updateExpressions = actionList;
	}
	public IndexMap getIndexMap() {
		return indexMap;
	}
	public ActionList getActionList() {
		return updateExpressions;
	}
}
