package dybip.InteractionStmt;

import dybip.Context;
import dybip.DyBIPArrayList;

public class ExecutableReconfigurationRuleList extends DyBIPArrayList<ExecutableReconfigurationRule>{
	public ExecutableReconfigurationRuleList(int size){
		super(size);
	}
	public ExecutableReconfigurationRuleList(){
		super();
	}
	public ExecutableReconfigurationRuleList(ReconfigurationRuleStmtList stmtList, Context context) {
		super(stmtList.size());
		for(int i = 0; i < stmtList.size(); i++) {
			add(new ExecutableReconfigurationRule(stmtList.get(i), context));
		}
	}
	@Override
	public String toString(){
		String str = "\t\t\tRECONFIGURATION RULES:\n";
		if(size() == 0)
			return str + "\t\t\tempty";
		for(int i = 0; i < size(); i++)
			str += "\t\t\tRULE " + i + ":\n" + get(i).toString() + "\n";
		return str;
	}
}
