package dybip.InteractionStmt;

import dybip.expression.Expression;

public class ForIterator extends Iterator {
	Range range;
	
	public ForIterator(String iteratorVar, Range range){
		super(iteratorVar, null);
		this.range = range;
	}
	public ForIterator(String iteratorVar, Range range, Expression expr){
		super(iteratorVar, expr);
		this.range = range;
	}
	public Range getRange() {
		return range;
	}
	@Override
	public String toString(){
		String str = "\tfor " + getIteratorVar() + " in " + range.toString() + ":";
		
		if(getExpr() != null)
			str += " " + getExpr().toString();
		return str; 
	}
	
}
