package dybip.InteractionStmt;

import dybip.DyBIPObject;
import dybip.expression.Expression;

public class Range extends DyBIPObject {
	Expression from;
	Expression to;
	
	public Range(Expression from, Expression to){
		this.from = from;
		this.to = to;
	}
	
	public Expression getFrom() {
		return from;
	}

	public Expression getTo() {
		return to;
	}

	@Override
	public String toString(){
		return "{" + from.toString() + ".." + to.toString() + "}" ;
	}
}
