package dybip.InteractionStmt;

import dybip.DyBIPObject;
import dybip.GuardActionPair;
import dybip.expression.list.ActionList;
import dybip.expression.list.GuardList;

public class RuleStmt extends DyBIPObject{

	private NestedIterators nestedIterators;
	private GuardActionPair guardAction;
	
	public RuleStmt(NestedIterators nestedIterators, GuardActionPair guardAction){
		this.nestedIterators = nestedIterators;
		this.guardAction = guardAction;
	}
	public NestedIterators getNestedIterators(){
		return nestedIterators;
	}
	public GuardActionPair getGuardAction(){
		return guardAction;
	}
	public GuardList getGuards(){
		return guardAction.getGuard();
	}
	public ActionList getActions(){
		return guardAction.getAction();
	}
	
}
