package dybip.componentInstance;

import dybip.expression.Expression;
import dybip.Context;

public class Data extends Expression {
	private String name;
	
	public Data(String name){
		this.name = name;
	}
	public void resetData(){};
	public String getTrace() {return "";};
	public void setData(Expression data){};
	
	public String getName(){
		return name;
	}
	@Override
	public Expression minify(Context context) {
		return context.find(name);
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return Data.class;
	}
	@Override
	public String toMinifyString(Context context) {
		return name;
	}

	@Override
	public String toString() {
		return name;
	}

	
}