package dybip.expression;

import dybip.DyBIPObject;
import dybip.Context;

public abstract class Expression extends DyBIPObject{
	public abstract Expression minify(Context context);
	public abstract Class<?> getExpressionType(Context context);
	public abstract String toString();
	public abstract String toMinifyString(Context context);
	
	public  <T> T  value(Class<T> type)
	{
		return this.value(type);
	}
	public void updateIndexes(Context context){
		
	}
	public Class<?> unifyType(Class<?> c1, Class<?> c2){
		// TODO update
		if(c1.isAssignableFrom(c2) || c1.equals(c2))
			return c2;
		else 
			return c1; // TODO incompatible types
	}
	
}
