package dybip.expression.list;

import dybip.expression.booleanExpr.BooleanExpression;
import dybip.Context;

public class GuardList extends ExpressionList<BooleanExpression>{
	
	public GuardList(int size){
		super(size);
	}
	public GuardList(){
		super();
	}
	public void addAll(GuardList list) {
		for(int i = 0; i < list.size(); i++){
			add(list.get(i));
		}
	}
	@Override
	public String toString(int toStringMode){
		return toString();
	}
	@Override
	public String toString(){
		if(size() == 0)
			return "[]";
		
		String result = "[" +  get(0);
		for(int i = 1 ; i < size();i ++)
		{
			result += ", " + get(i).toString();
		}
		result += "]";

		return result;
	}
	@Override
	public String toMinifyString(Context context){
		String result = "[" +  get(0);
		for(int i = 1 ; i < size();i ++)
		{
			result += ", " + get(i).toMinifyString(context);
		}
		result += "]";
		return result;
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return boolean.class;
	}
}
