package dybip.expression.variable;

import dybip.Context;

public class Index extends VariableExpression{
	private Integer value;
	public Index(String varName, Integer value){
		super(varName);
		this.value = value;
	}
	public void setValue(Integer value){
		this.value = value;
	}
	public String getName(){
		return getVariableName();
	}
	@Override
	public  <T> T  value(Class<T> type){
		return type.cast(value);
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return Integer.class;
	}
	@Override
	public String toString(){
		return getVariableName().toString() + "=" +  value;
	}
	@Override
	public String toString(int toStringMode){
		return getVariableName().toString() + "=" +  value;
	}
	@Override
	public String toMinifyString(Context context) {
		return value + "";
	}
}

	
