package dybip;

import java.util.HashMap;
import java.util.Set;


public class DyBIPHashMap<T, V> extends DyBIPObject{
	private HashMap<T, V> map;
	
	public DyBIPHashMap(int size){
		if (size == 0)
			map = new HashMap<T, V>();
		else
			map = new HashMap<T, V>(size);
	}
	public DyBIPHashMap(){
		map = new HashMap<T, V>();
	}
	public void put(T key, V elem){
		map.put(key, elem);
	}
	public V get(T key){
		return map.get(key);
	}
	public Set<T> keySet(){
		return map.keySet();
	}
	public void remove(T key) {
		map.remove(key);
	}
	public boolean containsKey(T key){
		return map.containsKey(key);
	}
	public boolean containsValue(V elem){
		return map.containsValue(elem);
	}
	public String toString(){
		return map.toString();
	}
	public int size(){
		return map.size();
	}
	public void clear(){
		map.clear();
	}
}
