package dybip.InteractionStmt;

import dybip.Context;
import dybip.IndexMap;
import dybip.expression.list.ActionList;

public class EnabledReconfiguration extends EnabledStep{
	
	public EnabledReconfiguration(ActionList actionList, IndexMap indexMap)
	{
		setActionList(actionList);
		setIndexMap(indexMap);
	}
	
	public void execute(Context context){
		context.setIndexMap(getIndexMap());
		getActionList().minify(context).value(Boolean.class);
		context.resetIndexMap();

	}
	public String toMinifyString(Context context) {
		context.setIndexMap(getIndexMap());
		String str = "\n\t\t" + getActionList().toMinifyString(context) + "\n";
		context.resetDataMap();
		return str;
	}
	@Override 
	public String toString(int toStringMode){
		String str = "\n\t\t" + getActionList().toString() + "\n";
		return str;
	}
}
