package dybip.InteractionStmt;

import dybip.expression.Expression;

public class ForEachIterator extends Iterator{
	private String iteratorType;
	
	public ForEachIterator(String iteratorvar, String iterartorType, Expression expr){
		super(iteratorvar, expr);
		this.iteratorType = iterartorType;
	}
	public ForEachIterator(String iteratorVar, String iterartorType){
		super(iteratorVar, null);
		this.iteratorType = iterartorType;
	}
	public String getIteratorType() {
		return iteratorType;
	}
	public String toString(){
		String str = "\tfor each " + iteratorType + " " + getIteratorVar() + ": ";
		
		if(getExpr() != null)
			return str += getExpr().toString();
		
		return str;
	}
}
