package dybip;

public class ParameterIncrement {
	private int value;
	private String operator;
	private int incrementValue;
	
	public ParameterIncrement(int value, String increment) {
		this.value = value;
		this.operator = increment.charAt(0) + "";
		this.incrementValue = Integer.parseInt(increment.substring(1));
	}
	
	public ParameterIncrement(String value, String increment) {
		this(Integer.parseInt(value), increment);
	}
	public int increment() {
		switch (operator){
		case "-": return value -= incrementValue;
		case "+": return value += incrementValue;
		case "*": return value *= incrementValue;
		default : return value /= incrementValue;
		}
	}
	public int getValue() {
		return value;
	}
	public String toString() {
		return value + " " + operator + " " + incrementValue;
	}

}
