package dybip.componentType;

import dybip.DyBIPObject;
import dybip.systemStmt.componentTypeStmt.DataTypeStmt;

public class DataType extends DyBIPObject {
	private String type;
	String variableName;
	
	public DataType(String type, String name){
		this.type = type;
		variableName = name;
	}
	public DataType(DataTypeStmt stmt){
		this(stmt.getType(), stmt.getName());
	}
	public String getType(){
		return type;
	}
	public String getName(){
		return variableName;
	}
	public String toString(int toStringMode){
		return "";
	}
	public String toString(){
		return type + " " + variableName;
	}
}