package dybip.componentType;
import dybip.DyBIPArrayList;
import dybip.systemStmt.componentTypeStmt.DataTypeStmtList;

public class DataTypeList extends DyBIPArrayList<DataType>{
	public DataTypeList(int size){
		super(size);
	}
	public DataTypeList(){
		super();
	}
	public DataTypeList( DataTypeStmtList stmtList){
		this(stmtList.size());
		for(int i = 0; i < stmtList.size(); i++){
			add(new DataType(stmtList.get(i)));
		}
	}
	@Override
	public String toString()
	{
		if(size() == 0)
			return "\t{}";
		else{
			String result = "\t{";
			for(int i = 0; i < size()-1; i++)
				result += get(i).toString() + ", ";
			result += get(size()-1);
			return result + "}";
		}
	}
}
