package dybip.componentType;

import dybip.DyBIPArrayList;

/**
 * This class represents a list of Ports. 
 * @author el-ballouli
 *
 */
public class PortList extends DyBIPArrayList<Port>{
	
	public PortList(){
		super();
	}
	public PortList(int size){
		super(size);
	}
	/**
	 * @returns Returns a string of all the port names in the list separated by comma. use to regenerate the code parsed 
	 */
	@Override
	public String toString()
	{
		if(size() == 0)
			return "";
		else{
			String result = "\t\tport ";
			for(int i = 0; i < size()-1; i++)
				result += get(i).toString() + ", ";
			result += get(size()-1);
			return result;
		}
	}
}
