package dybip.expression.binary;

import dybip.expression.Expression;
import dybip.Context;

public class BinaryExpression extends Expression{
	
	Expression expr1;
	Expression expr2;
	public BinaryExpression(Expression expr1, Expression expr2){
		this.expr1 = expr1;
		this.expr2 = expr2;
	}
	public Expression getExpression1(){
		return expr1;
	}
	public Expression getExpression2(){
		return expr2;
	}
	@Override
	public Expression minify(Context context) {
		return null;
	}
	@Override
	public String toString() {
		return null;
	}
	@Override
	public String toMinifyString(Context context) {
		return toString();
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		Class<?> c1 = expr1.getExpressionType(context);
		Class<?> c2 = expr2.getExpressionType(context);
		return unifyType(c1,c2) ;
	}
	
}
