package dybip.expression.list;

import dybip.expression.action.ActionExpression;
import dybip.Context;

public class ActionList extends ExpressionList<ActionExpression>{
	public ActionList(int size){
		super(size);
	}
	public ActionList(){
		super();
	}
	public void addAll(ActionList list){
		for(int i = 0; i < list.size(); i++){
			add(list.get(i));
		}
	}
	@Override
	public String toString(int toStringMode){
		return toString();
	}
	@Override
	public String toString(){
		if(size() == 0)
			return "{}";
		String result = "{" +  get(0);
		for(int i = 1 ; i < size();i ++)
			result += ", " + get(i).toString();
		result += "}";
		return result;
	}
	@Override
	public String toMinifyString(Context context){
		if(size() == 0)
			return "{}";
		String result = "{" +  get(0).toMinifyString(context);
		for(int i = 1 ; i < size();i ++)
		{
			result += ", " + get(i).toMinifyString(context);
		}
		result += "}";
		return result;
	}
}
