package dybip.expression.list;

import dybip.expression.variable.PortAccess;


import dybip.Context;


public class PortReferenceList extends ExpressionList<PortAccess> {
	public PortReferenceList(int size) {
		super(size);
	}
	public PortReferenceList() {
		super();
	}

	@Override
	public String toMinifyString(Context context){
		String str = "";
		for(int i = 0; i < size(); i++)
			if(i == size() - 1)
				str += get(i).toMinifyString(context);
			else
				str += get(i).toMinifyString(context) + ", ";
		return str;
	}
	@Override
	public String toString(){
		String str = "";
		for(int i = 0; i < size(); i++)
			if(i == size() - 1)
				str += get(i).toString();
			else
				str += get(i).toString() + ", ";
		return str;
	}
}
