package dybip.expression.literal;

import dybip.expression.Expression;
import dybip.Context;

public class NullLiteral extends LiteralExpression{
	public NullLiteral(){
	}
	@Override
	public String toString() {
		return null;
	}
	@Override
	public String toMinifyString(Context context) {
		return toString();
	}
	@Override
	public Expression minify(Context context) {
		return this;
	}
	@Override
	public Class<?> getExpressionType(Context context){
		return NullLiteral.class;
	}
	@Override
	public  <T> T  value(Class<T> type){
		return (T) null;
	}

}
