package dybip.expression.unary;

import dybip.expression.Expression;
import dybip.Context;

public class ParenthesizedExpression extends UnaryExpression {
	
	public ParenthesizedExpression(Expression expr){
		super(expr);
	}
	@Override
	public String toString(){
		return "(" + expr.toString() + ")";
	}
	@Override
	public String toMinifyString(Context context){
		return "(" + expr.toMinifyString(context) + ")";
	}
	@Override
	public Expression minify(Context context){
		return expr.minify(context);
	}
}
