package dybip.expression.unary;

import dybip.expression.Expression;
import dybip.Context;

public class UnaryExpression extends Expression{

	Expression expr;
	public UnaryExpression(){
		
	}
	public UnaryExpression(Expression expr){
		this.expr  = expr;
	}
	public Expression getExpression(){
		return expr;
	}
	@Override
	public String toString(){
		return expr.toString();
	}
	@Override
	public String toMinifyString(Context context) {
		return expr.toMinifyString(context);
	}
	@Override 
	public <T> T value(java.lang.Class<T> type) {
		return expr.value(type);
	}
	@Override
	public Expression minify(Context context){
		return expr.minify(context);
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return expr.getExpressionType(context);
	}
	
}
