package dybip.expression.variable;

import dybip.expression.Expression;
import dybip.Context;

public class VariableExpression extends Expression{
	public String str;
	public VariableExpression(String varName){
		str = varName;
	}
	public String getVariableName(){
		return str;
	}
	@Override
	public Expression minify(Context context){
		return context.find(str);
	}
	@Override
	public Class<?> getExpressionType(Context context) {
		return minify(context).getExpressionType(context);
	}
	
	@Override
	public String toString (){
		return str;
	}
	@Override
	public String toMinifyString(Context context) {
		if(minify(context) instanceof Index)
			return minify(context).toMinifyString(context);
		else
			return str;
	}

	
}
