package dybip.motifInstance;

import java.util.Set;

import dybip.DyBIPHashMap;

public class ComponentGroupMap extends DyBIPHashMap<String, Group>{

	public ComponentGroupMap(){
		super();
	}
	public ComponentGroupMap(int size) {
		super(size);
	}
	public String getTrace() {
		String trace = "";
		for(String groupName: keySet()) {
			trace += get(groupName).getTrace();
		}
		return trace;
	}
	public String toString(){
		String result = "";
		Set<String> groupNames = keySet();
		for(String s : groupNames)
			result += "\t\t\t" + s + " {" + get(s).toString() + "}\n";
		return result ;
	}
}
