package dybip.systemStmt.componentTypeStmt;

import dybip.DyBIPObject;

public class ComponentTypeStmt extends DyBIPObject{
	private String name;
	private DataTypeStmtList dataList;
	private PortStmtList portList;
	private InitTransitionStmt initTrans;
	private TransitionStmtList transitions;
	
	public ComponentTypeStmt(String name, PortStmtList p, DataTypeStmtList d, InitTransitionStmt initTrans, TransitionStmtList transition){
		portList = p;
		this.name = name;
		dataList = d;
		this.initTrans = initTrans;
		this.transitions = transition;
	}
	public TransitionStmtList getTransitions(){
		return transitions;
	}
	public InitTransitionStmt getInitTransition(){
		return initTrans;
	}
	public DataTypeStmtList getDataTypeStmtList(){
		return dataList;
	}
	@Override
	public String toString(){
		String result =  "\n\tcomponent type " + getName() + "\n" 
				 + portList.toString() + "\n" 
				 + dataList.toString() + "\n" 
				 + initTrans.toString() + "\n"
				 + transitions.toString() + "\n"
				 + "\tend\n";
		
		return result;
	}
	public String getName(){
		return name;
	}
	
	
}
