package dybip.systemStmt.motifTypeStmt;

import dybip.DyBIPObject;
import dybip.InteractionStmt.InteractionRuleStmtList;
import dybip.InteractionStmt.ReconfigurationRuleStmtList;

public class MotifTypeStmt extends DyBIPObject{
	
	private String name;
	private ReferStmtList referals;
	private ComponentInstanceStmtList instances;
	private ReconfigurationRuleStmtList reconfigRuleList;
	private InteractionRuleStmtList interactionRuleList;
	
	public MotifTypeStmt(String name, ReferStmtList referals, ComponentInstanceStmtList instancesList, ReconfigurationRuleStmtList reconfigRuleList, InteractionRuleStmtList interactionRuleList){
		this.name = name;
		this.referals = referals;
		this.instances = instancesList;
		this.reconfigRuleList = reconfigRuleList;
		this.interactionRuleList = interactionRuleList;
	}
	public String getName(){
		return name;
	}
	public ReferStmtList getReferStmtList(){
		return referals;
	}
	public ComponentInstanceStmtList getComponentInstanceStmtList(){
		return instances;
	}
	public ReconfigurationRuleStmtList getReconfigRuleStmtList(){
		return reconfigRuleList;
	}
	public InteractionRuleStmtList getInteractionRuleStmtList(){
		return interactionRuleList;
	}
	public String toString(){
		String  str = "\n\tmotif type " + name + "\n" + 
							referals.toString() + "\n" + 
							instances.toString() + "\n" +
							reconfigRuleList.toString() + "\n" +
							interactionRuleList.toString() + "\tend\n";
		
		return str;
		
	}
}
